


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: AdministratorService</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.service</a> ]
</div>

<h1>Coverage Summary for Class: AdministratorService (com.dema.timeregistration.service)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">AdministratorService</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    66.7%
  </span>
  <span class="absValue">
    (4/ 6)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    86.7%
  </span>
  <span class="absValue">
    (26/ 30)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.service;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import com.dema.timeregistration.entity.Company;
<i>4</i>&nbsp;import com.dema.timeregistration.entity.GlobalRole;
<i>5</i>&nbsp;import com.dema.timeregistration.entity.User;
<i>6</i>&nbsp;import com.dema.timeregistration.repository.CompanyRepository;
<i>7</i>&nbsp;import com.dema.timeregistration.repository.UserRepository;
<i>8</i>&nbsp;import com.dema.timeregistration.service.exception.AccessDeniedException;
<i>9</i>&nbsp;import com.dema.timeregistration.service.exception.EntityAlreadyExistsException;
<i>10</i>&nbsp;import com.dema.timeregistration.service.exception.EntityNotFoundException;
<i>11</i>&nbsp;import com.dema.timeregistration.service.models.UpdateCompanyRequest;
<i>12</i>&nbsp;
<i>13</i>&nbsp;import java.util.stream.Collectors;
<i>14</i>&nbsp;
<i>15</i>&nbsp;public class AdministratorService {
<i>16</i>&nbsp;    private final UserRepository userRepository;
<i>17</i>&nbsp;    private final CompanyRepository companyRepository;
<i>18</i>&nbsp;    private final UserAccessService userAccessService;
<i>19</i>&nbsp;
<i>20</i>&nbsp;    public AdministratorService(UserRepository userRepository,
<i>21</i>&nbsp;                                CompanyRepository companyRepository,
<b class="fc"><i>22</i>&nbsp;                                UserAccessService userAccessService) {</b>
<b class="fc"><i>23</i>&nbsp;        this.userRepository = userRepository;</b>
<b class="fc"><i>24</i>&nbsp;        this.companyRepository = companyRepository;</b>
<b class="fc"><i>25</i>&nbsp;        this.userAccessService = userAccessService;</b>
<b class="fc"><i>26</i>&nbsp;    }</b>
<i>27</i>&nbsp;
<i>28</i>&nbsp;    public void setGlobalRole(int userId, GlobalRole globalRole, UserContext userContext) throws EntityNotFoundException, AccessDeniedException {
<b class="fc"><i>29</i>&nbsp;        userAccessService.throwIfUserIsNotAdmin(userContext);</b>
<i>30</i>&nbsp;
<b class="fc"><i>31</i>&nbsp;        if (globalRole != GlobalRole.GLOBAL_ADMINISTRATOR &amp;&amp; userRepository.countByGlobalRole(GlobalRole.GLOBAL_ADMINISTRATOR) == 1) {</b>
<b class="fc"><i>32</i>&nbsp;            throw new AccessDeniedException(&quot;There must be at least one administrator at all times&quot;);</b>
<i>33</i>&nbsp;        }
<i>34</i>&nbsp;
<b class="fc"><i>35</i>&nbsp;        User user = userRepository.findById(userId).orElseThrow(EntityNotFoundException::userNotFound);</b>
<b class="fc"><i>36</i>&nbsp;        user.setGlobalRole(globalRole);</b>
<b class="fc"><i>37</i>&nbsp;        userRepository.save(user);</b>
<b class="fc"><i>38</i>&nbsp;    }</b>
<i>39</i>&nbsp;
<i>40</i>&nbsp;    public void createCompany(String name, UserContext userContext) throws AccessDeniedException, EntityNotFoundException, EntityAlreadyExistsException {
<b class="fc"><i>41</i>&nbsp;        userAccessService.throwIfUserIsNotAdmin(userContext);</b>
<i>42</i>&nbsp;
<b class="fc"><i>43</i>&nbsp;        if (companyRepository.existsByName(name)) {</b>
<b class="fc"><i>44</i>&nbsp;            throw new EntityAlreadyExistsException(&quot;A company with the specified name already exists&quot;);</b>
<i>45</i>&nbsp;        }
<i>46</i>&nbsp;
<b class="fc"><i>47</i>&nbsp;        Company company = Company.create(name);</b>
<b class="fc"><i>48</i>&nbsp;        companyRepository.save(company);</b>
<b class="fc"><i>49</i>&nbsp;    }</b>
<i>50</i>&nbsp;
<i>51</i>&nbsp;    public void updateCompany(UpdateCompanyRequest updateCompanyRequest, UserContext userContext) throws EntityNotFoundException, AccessDeniedException, EntityAlreadyExistsException {
<b class="fc"><i>52</i>&nbsp;        userAccessService.throwIfUserIsNotAdmin(userContext);</b>
<i>53</i>&nbsp;
<b class="fc"><i>54</i>&nbsp;        if (companyRepository.existsByNameAndIdNot(updateCompanyRequest.getName(), updateCompanyRequest.getId())) {</b>
<b class="fc"><i>55</i>&nbsp;            throw new EntityAlreadyExistsException(&quot;A company with the specified name already exists&quot;);</b>
<i>56</i>&nbsp;        }
<i>57</i>&nbsp;
<b class="fc"><i>58</i>&nbsp;        Company company = companyRepository.findById(updateCompanyRequest.getId()).orElseThrow(EntityNotFoundException::companyNotFound);</b>
<i>59</i>&nbsp;
<b class="fc"><i>60</i>&nbsp;        if (updateCompanyRequest.getName() != null) {</b>
<b class="fc"><i>61</i>&nbsp;            company.setName(updateCompanyRequest.getName());</b>
<i>62</i>&nbsp;        }
<i>63</i>&nbsp;
<b class="fc"><i>64</i>&nbsp;        companyRepository.save(company);</b>
<b class="fc"><i>65</i>&nbsp;    }</b>
<i>66</i>&nbsp;
<i>67</i>&nbsp;    public int getCompanyId(String name) throws EntityNotFoundException {
<b class="nc"><i>68</i>&nbsp;        return this.companyRepository.findByName(name).orElseThrow(EntityNotFoundException::companyNotFound).getId();</b>
<i>69</i>&nbsp;    }
<i>70</i>&nbsp;
<i>71</i>&nbsp;    public String listCompanies() {
<b class="nc"><i>72</i>&nbsp;        return companyRepository.findAll().stream()</b>
<b class="nc"><i>73</i>&nbsp;                .map(Company::getName)</b>
<b class="nc"><i>74</i>&nbsp;                .collect(Collectors.joining(&quot;\n&quot;));</b>
<i>75</i>&nbsp;    }
<i>76</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
